
#include <ArduinoBLE.h>
#define SERVICE_UUID "19B10000-E8F2-537E-4F6C-D104768A1214"
#define DIGITAL_READ_CHARACT_UUID "19B10001-E8F2-537E-4F6C-D104768A1214"
#define DIGITAL_WRITE_CHARACT_UUID "19B10002-E8F2-537E-4F6C-D104768A1214"
#define PIN_IN 2
#define PIN_OUT 3
            
BLEService digitalService(SERVICE_UUID);   
            
BLEByteCharacteristic digitalReadChar(DIGITAL_READ_CHARACT_UUID,BLERead|BLENotify);
BLEByteCharacteristic digitalWriteChar(DIGITAL_WRITE_CHARACT_UUID,BLEWrite);
             
BLEDescriptor digitalReadDescriptor("2901","digitalRead");
BLEDescriptor digitalWriteDescriptor("2901","digitalWrite");
               
void setup() {
  Serial.begin(9600);
  while (!Serial);  
  pinMode(PIN_IN,INPUT);
  pinMode(PIN_OUT,OUTPUT);
  if (!BLE.begin()) {
    Serial.println("échec du démarrage de BLE");
    while (1);
  }
  digitalReadChar.addDescriptor(digitalReadDescriptor);
  digitalWriteChar.addDescriptor(digitalWriteDescriptor);
  BLE.setLocalName("DigitalRead");
  BLE.setAdvertisedService(digitalService);
  digitalService.addCharacteristic(digitalReadChar);
  digitalService.addCharacteristic(digitalWriteChar);
  BLE.addService(digitalService);
  BLE.advertise();
}
               
void loop() {
  BLEDevice central = BLE.central();
  Serial.println("BLE central détecté...");
  
  if (central) {
    Serial.println("Connexion au BLE central ");
    Serial.print("adresse MAC : ");
    Serial.println(central.address());
    Serial.println(" ");

    while(central.connected()) {
        delay(1000);
        digitalReadChar.writeValue(digitalRead(PIN_IN));
        if (digitalWriteChar.written()) {
            uint8_t state;
            state = digitalWriteChar.value();
            Serial.print("Digital write = ");
            Serial.println(state);
            digitalWrite(PIN_OUT,state);
        }
    }
    Serial.println("déconnexion du BLE central");

  }

}
               